How to catch and print the full exception traceback without halting/exiting the program? How to catch and print the full exception traceback without halting/exiting the program? python python

How to catch and print the full exception traceback without halting/exiting the program?


traceback.format_exc() or sys.exc_info() will yield more info if that's what you want.

import tracebackimport systry:    do_stuff()except Exception:    print(traceback.format_exc())    # or    print(sys.exc_info()[2])


Some other answer have already pointed out the traceback module.

Please notice that with print_exc, in some corner cases, you will not obtain what you would expect. In Python 2.x:

import tracebacktry:    raise TypeError("Oups!")except Exception, err:    try:        raise TypeError("Again !?!")    except:        pass    traceback.print_exc()

...will display the traceback of the last exception:

Traceback (most recent call last):  File "e.py", line 7, in <module>    raise TypeError("Again !?!")TypeError: Again !?!

If you really need to access the original traceback one solution is to cache the exception infos as returned from exc_info in a local variable and display it using print_exception:

import tracebackimport systry:    raise TypeError("Oups!")except Exception, err:    try:        exc_info = sys.exc_info()        # do you usefull stuff here        # (potentially raising an exception)        try:            raise TypeError("Again !?!")        except:            pass        # end of useful stuff    finally:        # Display the *original* exception        traceback.print_exception(*exc_info)        del exc_info

Producing:

Traceback (most recent call last):  File "t.py", line 6, in <module>    raise TypeError("Oups!")TypeError: Oups!

Few pitfalls with this though:

  • From the doc of sys_info:

    Assigning the traceback return value to a local variable in a function that is handling an exception will cause a circular reference. This will prevent anything referenced by a local variable in the same function or by the traceback from being garbage collected. [...] If you do need the traceback, make sure to delete it after use (best done with a try ... finally statement)

  • but, from the same doc:

    Beginning with Python 2.2, such cycles are automatically reclaimed when garbage collection is enabled and they become unreachable, but it remains more efficient to avoid creating cycles.


On the other hand, by allowing you to access the traceback associated with an exception, Python 3 produce a less surprising result:

import tracebacktry:    raise TypeError("Oups!")except Exception as err:    try:        raise TypeError("Again !?!")    except:        pass    traceback.print_tb(err.__traceback__)

... will display:

  File "e3.py", line 4, in <module>    raise TypeError("Oups!")


If you're debugging and just want to see the current stack trace, you can simply call:

traceback.print_stack()

There's no need to manually raise an exception just to catch it again.


matomo